apiVersion: apps/v1
kind: Deployment
metadata:
  name: {{ include "centurion.fullname" . }}-backend
  labels:
    {{- include "centurion.labels" . | nindent 4 }}
    app.kubernetes.io/component: backend
spec:
  replicas: {{ .Values.centurion.replicas }}
  selector:
    matchLabels:
      {{- include "centurion.selectorLabels" . | nindent 6 }}
      app.kubernetes.io/component: backend
  strategy:
    type: Recreate
  template:
    metadata:
      {{- with .Values.podAnnotations }}
      annotations:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      labels:
        {{- include "centurion.selectorLabels" . | nindent 8 }}
        app.kubernetes.io/component: backend
    spec:
      {{- with .Values.imagePullSecrets }}
      imagePullSecrets:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      containers:
        - name: centurion
          image: "{{ .Values.image.repository }}/backend:{{ .Values.image.tag | default "latest" }}"
          imagePullPolicy: {{ .Values.image.pullPolicy }}
          ports:
            - name: http
              containerPort: 3001
              protocol: TCP
          startupProbe:
            httpGet:
              path: /state
              port: http
            timeoutSeconds: 5
            failureThreshold: 6
            periodSeconds: 5
          livenessProbe:
            httpGet:
              path: /state
              port: http
            timeoutSeconds: 5
            failureThreshold: 6
          readinessProbe:
            httpGet:
              path: /state
              port: http
            timeoutSeconds: 5
            failureThreshold: 6
          env:
          {{- include "centurion.appEnvironment" . | nindent 10 }}
          resources:
            {{- toYaml .Values.resources | nindent 12 }}
      {{- with .Values.nodeSelector }}
      nodeSelector:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      {{- with .Values.affinity }}
      affinity:
        {{- toYaml . | nindent 8 }}
      {{- end }}
      {{- with .Values.tolerations }}
      tolerations:
        {{- toYaml . | nindent 8 }}
      {{- end }}
